<script>
  import { extent, map } from "d3-array";
  import { scaleLinear } from "d3-scale";
  import { axisBottom, axisLeft } from "d3-axis";
  import {brush} from "d3-brush";
  import {select, selectAll} from "d3-selection";
  import { onMount } from "svelte";

  // Properties
  export let data = [];
  export let x = (d) => d.x;
  export let y = (d) => d.y;
  export let xLabel = "x";
  export let yLabel = "y";

  export let global_array = []
  export let local_array = []


  // Dimensions
  const width = 400;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 35, left: 45 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Scales
  const xScale = scaleLinear().domain(extent(data, x)).range([0, innerWidth]);
  const yScale = scaleLinear().domain(extent(data, y)).range([innerHeight, 0]);

  // Axes
  const xAxis = (node) => axisBottom(xScale)(select(node));
  const yAxis = (node) => axisLeft(yScale)(select(node));

  // Brushing
  // The range of the selection rectangle.
  // If there is no active selection, it contains: null,
  // otherwise, it contains: [ [x0, y0], [x1, y1] ]
  let range = null;

  let dots;
  let svg;
  let coords;

  coords = data.map(d => { return { x: xScale(x(d)), y: yScale(y(d)) }; });

  onMount(() => {
    dots = select(svg).selectAll("circle")//.data(data)
    select(svg).call(brush().on('start brush end', brushMoving) )
    
  });

  function brushMoving(selection) {
    let value = [];
    if (selection.selection) {
      range = selection.selection;
    } 
    else {
      range = null;
    }
  }

  $: {
    if(range) 
    {
      let [[x0, y0], [x1, y1]]  = range
      x0 = x0 - margin.left 
      x1 = x1 - margin.left
      y0 = y0 - margin.top
      y1 = y1 - margin.top 
      
      local_array = coords.map(d => (x0 <= d.x 
      && d.x < x1
      && y0 <= d.y 
       && d.y < y1) )

    } else {
      local_array = coords.map(d => true)
    }
  }
</script>

<svg viewBox="0 0 {width} {height}" class="mx-2" style="max-width: {width}px" id="BrushingLinking" bind:this={svg}>
  <g transform="translate({margin.left},{margin.top})">
    <g>
      {#each coords as {x,y},idx}
        <circle
          cx={x}
          cy={y}
          r={3}
          fill= {global_array[idx] ? "steelblue" : "darkgray"}
          fill-opacity={global_array[idx] ? 0.8 : 0.3}
          stroke={global_array[idx] ? "steelblue" : "darkgray"}
          stroke-width={global_array[idx] ? 1 : 0.5}
          stroke-opacity={global_array[idx] ? 1 : 0.5}
        />
      {/each}
    </g>
    <g use:xAxis transform="translate(0, {innerHeight})">
      <text class="axisLabel" x={innerWidth / 2} y={margin.bottom - 5}
        >{xLabel}</text
      >
    </g>
    <g use:yAxis>
      <text
        class="axisLabel"
        y={-margin.left + 10}
        x={-innerHeight / 2}
        transform="rotate(-90)">{yLabel}</text
      >
    </g>
  </g>
</svg>

<style>
  .axisLabel {
    text-anchor: middle;
    vertical-align: bottom;
    fill: currentcolor;
  }
</style>

